//+------------------------------------------------------------------+
//|                                               ThierryRSI_CCI.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrDodgerBlue
#property indicator_color2  clrSandyBrown
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern ENUM_TIMEFRAMES timeFrame = PERIOD_CURRENT;
extern int             CCIPeriod = 14;
extern int             RSIPeriod = 8;
extern bool            alertsOn        = true;
extern bool            alertsOnCurrent = false;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsEmail     = false;

//
//
//
//
//

double   Trend[];
double   histou[];
double   histod[];
double   Direction[];
string   IndicatorFileName;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0, histou); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1, histod); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2, Trend);
      SetIndexBuffer(3, Direction);
         SetIndexLabel(0,"SuperTrend");
         SetIndexLabel(1,"SuperTrend");
        
   timeFrame = MathMax(timeFrame,_Period);
   IndicatorFileName = WindowExpertName();
   IndicatorShortName("ThierryTrend "+TimeFrameToString(timeFrame));    
   return(0);
}
int deinit()
{
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int      counted_bars = IndicatorCounted();
   int      limit,i;
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMax(Bars-counted_bars,Bars-1);


   //
   //
   //
   //
   //

      if (timeFrame != Period())
      {
         limit = MathMin(MathMax(limit,3*timeFrame/Period()),Bars-1);
         
            //
            //
            //
            //
            //
         
            for(i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);
                  histod[i]    = EMPTY_VALUE;
                  histou[i]    = EMPTY_VALUE;
                  Direction[i] = iCustom(NULL,timeFrame,IndicatorFileName,PERIOD_CURRENT,CCIPeriod,RSIPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
                     if (Direction[i]==-1) 
                           histod[i] = 1;
                     else  histou[i] = 1;        
            }
         return(0);         
      }

   //
   //
   //
   //
   //
   //
   //
   //
   //
   //
      
   for(i = limit; i >= 0; i--)
   {
         double cciTrend = iCCI(NULL, 0, CCIPeriod, PRICE_TYPICAL, i);
         double rsiTrend = iRSI(NULL, 0, RSIPeriod, PRICE_TYPICAL, i);
         
         //
         //
         //
         //
         //
         
         histod[i]    = EMPTY_VALUE;
         histou[i]    = EMPTY_VALUE;
         Trend[i]     = Trend[i+1];
         Direction[i] = Direction[i+1];
            if (cciTrend > 0 && rsiTrend > 50) { Trend[i] = MathMax(Low[i]  - iATR(NULL, 0, 5, i),Trend[i+1]); Direction[i] =  1; }
            if (cciTrend < 0 && rsiTrend < 50) { Trend[i] = MathMin(High[i] + iATR(NULL, 0, 5, i),Trend[i+1]); Direction[i] = -1; }
            if (Direction[i]==-1) 
                  histod[i] = 1;
            else  histou[i] = 1;        
   }
   manageAlerts();        
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string TimeFrameToString(int tf)
{
   string tfs="";
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (Direction[whichBar] != Direction[whichBar+1])
      {
         if (Direction[whichBar]== 1) doAlert(whichBar,"up");
         if (Direction[whichBar]==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  TimeFrameToString(Period())+" "+StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Thiery RSI-CCI trend chaged to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Thiery RSI-CCI trend "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}